<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:file="http://expath.org/ns/file"
                xmlns:shared="urn:shared-functions"
                xmlns:local="urn:local-functions"
                exclude-result-prefixes="#all"
                extension-element-prefixes="saxon"
                version="2.0">
   <xsl:import href="shared-functions.xslt"/>
   <xsl:param name="input-folder" as="xs:string"/>
   <xsl:param name="purge-date" as="xs:string"/>
   <xsl:variable name="xml-folder" select="file:path-to-uri($input-folder)"/>
   <xsl:strip-space elements="*"/>
   <!-- *********************************************************************************************************** -->
   <xsl:template name="xsl:initial-template" match="/">
      <xsl:call-template name="local:remove-past-versions-for-a371"/>
      <xsl:call-template name="local:complete-ptcar"/>
   </xsl:template>
   <!-- *********************************************************************************************************** -->
   <xsl:template name="local:remove-past-versions-for-a371">
      <xsl:call-template name="shared:transform">
         <xsl:with-param name="options" as="map(*)">
            <xsl:map>
               <xsl:map-entry key="'stylesheet-location'" select="'remove-past-versions.xslt'"/>
               <xsl:map-entry key="'stylesheet-params'">
                  <xsl:map>
                     <xsl:map-entry key="QName('', 'xml-folder')" select="$xml-folder"/>
                     <xsl:map-entry key="QName('', 'file-names')" select="('ptcar', 'region')"/>
                     <xsl:map-entry key="QName('', 'purge-date')" select="$purge-date"/>
                  </xsl:map>
               </xsl:map-entry>
            </xsl:map>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <!-- *********************************************************************************************************** -->
   <xsl:template name="local:complete-ptcar">
      <xsl:call-template name="shared:transform">
         <xsl:with-param name="options" as="map(*)">
            <xsl:map>
               <xsl:map-entry key="'stylesheet-location'" select="'complete-ptcar.xslt'"/>
               <xsl:map-entry key="'source-location'" select="resolve-uri('filtered-ptcar.xml', $xml-folder)"/>
               <xsl:map-entry key="'base-output-uri'" select="resolve-uri('completed-ptcar.xml', $xml-folder)"/>
               <xsl:map-entry key="'stylesheet-params'">
                  <xsl:map>
                     <xsl:map-entry key="QName('', 'region-file')" select="resolve-uri('filtered-region.xml', $xml-folder)"/>
                     <xsl:map-entry key="QName('', 'purge-date')" select="$purge-date"/>
                  </xsl:map>
               </xsl:map-entry>
            </xsl:map>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <!-- *********************************************************************************************************** -->
</xsl:stylesheet>
