<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                exclude-result-prefixes="#all"
                version="2.0">
   <xsl:param name="xml-folder" as="xs:string"/>
   <xsl:param name="file-names" as="xs:string*"/>
   <xsl:param name="purge-date" as="xs:string"/>
   <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
   <xsl:strip-space elements="*"/>
   <!-- *********************************************************************************************************** -->
   <xsl:template name="xsl:initial-template" match="/">
      <xsl:for-each select="$file-names">
         <xsl:variable name="inputFile" select="doc(resolve-uri(concat(., '.xml'), $xml-folder))"/>
         <xsl:variable name="outputFile" select="resolve-uri(concat('filtered-', ., '.xml'), $xml-folder)"/>
         <xsl:for-each select="$inputFile">
            <xsl:result-document href="{$outputFile}">
               <xsl:apply-templates/>
            </xsl:result-document>
         </xsl:for-each>
      </xsl:for-each>
<!--      <dummy/>-->
   </xsl:template>
   <!-- *********************************************************************************************************** -->
   <xsl:template match="*">
      <xsl:copy>
         <xsl:sequence select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>
   <!-- *********************************************************************************************************** -->
   <xsl:template match="*[exists(@validToDate)]">
      <xsl:if test="@validToDate ge $purge-date">
         <xsl:sequence select="."/>
      </xsl:if>
   </xsl:template>
   <!-- *********************************************************************************************************** -->
</xsl:stylesheet>